Blob


1 #!/bin/sh
2 #
3 # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 #
5 # Permission to use, copy, modify, and distribute this software for any
6 # purpose with or without fee is hereby granted, provided that the above
7 # copyright notice and this permission notice appear in all copies.
8 #
9 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17 export GIT_AUTHOR_NAME="Flan Hacker"
18 export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 export GOT_AUTHOR_8="flan_hac"
23 export GOT_LOG_DEFAULT_LIMIT=0
25 export MALLOC_OPTIONS=S
27 function git_init
28 {
29 git init -q "$1"
30 }
32 function git_commit
33 {
34 local repo="$1"
35 shift
36 (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
37 }
39 function git_rm
40 {
41 local repo="$1"
42 shift
43 (cd $repo && git rm -q "$@")
44 }
46 function git_show_head
47 {
48 local repo="$1"
49 (cd $repo && git show --no-patch --pretty='format:%H')
50 }
52 function git_show_author_time
53 {
54 local repo="$1"
55 (cd $repo && git show --no-patch --pretty='format:%at')
56 }
58 function git_show_parent_commit
59 {
60 local repo="$1"
61 (cd $repo && git show --no-patch --pretty='format:%P')
62 }
64 function git_show_tree
65 {
66 local repo="$1"
67 (cd $repo && git show --no-patch --pretty='format:%T')
68 }
70 function trim_obj_id
71 {
72 let trimcount=$1
73 id=$2
75 pat=""
76 while [ trimcount -gt 0 ]; do
77 pat="[0-9a-f]$pat"
78 let trimcount--
79 done
81 echo ${id%$pat}
82 }
84 function git_commit_tree
85 {
86 local repo="$1"
87 local msg="$2"
88 local tree="$3"
89 (cd $repo && git commit-tree -m "$msg" "$tree")
90 }
92 function make_test_tree
93 {
94 repo="$1"
96 echo alpha > $repo/alpha
97 echo beta > $repo/beta
98 mkdir $repo/gamma
99 echo delta > $repo/gamma/delta
100 mkdir $repo/epsilon
101 echo zeta > $repo/epsilon/zeta
104 function get_blob_id
106 repo="$1"
107 tree_path="$2"
108 filename="$3"
110 got tree -r $repo -i $tree_path | grep ${filename}$ | cut -d' ' -f 1
113 function test_init
115 local testname="$1"
116 local no_tree="$2"
117 if [ -z "$testname" ]; then
118 echo "No test name provided" >&2
119 return 1
120 fi
121 local testroot=`mktemp -p /tmp -d got-test-$testname-XXXXXXXX`
122 mkdir $testroot/repo
123 git_init $testroot/repo
124 if [ -z "$no_tree" ]; then
125 make_test_tree $testroot/repo
126 (cd $repo && git add .)
127 git_commit $testroot/repo -m "adding the test tree"
128 fi
129 echo "$testroot"
132 function test_cleanup
134 local testroot="$1"
136 (cd $testroot/repo && git fsck --strict \
137 > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
138 ret="$?"
139 if [ "$ret" != "0" ]; then
140 echo -n "git fsck: "
141 cat $testroot/fsck.stderr
142 echo "git fsck failed; leaving test data in $testroot"
143 return 1
144 fi
146 rm -rf "$testroot"
149 function run_test
151 testfunc="$1"
152 echo -n "$testfunc "
153 $testfunc
156 function test_done
158 local testroot="$1"
159 local result="$2"
160 if [ "$result" == "0" ]; then
161 test_cleanup "$testroot" || return 1
162 echo "ok"
163 elif echo "$result" | grep -q "^xfail"; then
164 # expected test failure; test reproduces an unfixed bug
165 echo "$result"
166 test_cleanup "$testroot" || return 1
167 else
168 echo "test failed; leaving test data in $testroot"
169 fi